Bug 1044048 - cluster configuration schema-based validation hardening
Summary: cluster configuration schema-based validation hardening
Keywords:
Status: CLOSED DEFERRED
Alias: None
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: cluster
Version: 6.5
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: rc
: ---
Assignee: Jan Pokorný [poki]
QA Contact: cluster-qe@redhat.com
URL:
Whiteboard:
Depends On: 1044057
Blocks:
TreeView+ depends on / blocked
 
Reported: 2013-12-17 17:13 UTC by Jan Pokorný [poki]
Modified: 2016-08-24 21:08 UTC (History)
6 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
: 1272587 (view as bug list)
Environment:
Last Closed: 2016-08-24 21:08:40 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Bugzilla 557344 None None None Never
Red Hat Bugzilla 680930 None None None Never
Red Hat Bugzilla 1173942 None None None Never

Internal Links: 557344 680930 1173942

Description Jan Pokorný [poki] 2013-12-17 17:13:55 UTC
Definitely, we can do a better job in determining correctness of the given
cluster stack configuration (in the form of cluster.conf).  What currently
validates successfully is a very rough overapproximation of actually
correct and sound configuration.  Granted, the ideas behind original
Relax NG schema modularization ([bug 680930], virtually first milestone
on this road) are to preserved.

This bug is to both (1) track the work in this direction in the cman's
package scope and (2) to be blocked by subordinate bugs for other packages
involved (fence-agents, resource-agents, etc.).  This bug should serve as
a central point for any discussion on the (generalized) topic.

For (1), current progress is captured in the cluster-devel ML [1] (with
many back-and-forth iterations due to the complex nature of the changes)
and in branches following STABLE32 [2] and (dependent) RHEL65 [3] ones.

[1] http://www.redhat.com/archives/cluster-devel/2013-December/msg00037.html
    http://www.redhat.com/archives/cluster-devel/2013-December/msg00052.html
    http://www.redhat.com/archives/cluster-devel/2013-December/msg00084.html
    http://www.redhat.com/archives/cluster-devel/2013-December/msg00088.html
    http://www.redhat.com/archives/cluster-devel/2013-December/msg00125.html
    http://www.redhat.com/archives/cluster-devel/2013-December/msg00134.html

[2] https://git.fedorahosted.org/cgit/cluster.git/log/?h=STABLE32-feature-schema-hardening
[3] https://git.fedorahosted.org/cgit/cluster.git/log/?h=RHEL6x-feature-schema-hardening

Comment 2 Jan Pokorný [poki] 2013-12-17 17:26:52 UTC
> ([bug 680930], virtually first milestone on this road)

because of the vital decentralization of the "correctness" knowledge,
shifting it towards particular components

Comment 5 Jan Pokorný [poki] 2014-12-04 20:13:20 UTC
Another thing that should have been captured in the schema:
https://git.fedorahosted.org/cgit/cluster.git/commit/?h=STABLE32-feature-schema-hardening&id=a6bdeb5bb4d6137e315a6c19a8d72f1ecb2cec0a

Comment 7 Jan Pokorný [poki] 2014-12-16 15:44:40 UTC
Another discovery (thanks to Piyush Sharma):

/cluster/rm/resources/action -> wrong
/cluster/rm/resources/SOMETHING/action -> ok (for SOMETHING in clusterfs, ip, ...)

As a side effect, wrongly-alleged-valid first case is what makes luci
choke: [bug 1173942].

Comment 9 Jan Pokorný [poki] 2014-12-16 17:03:15 UTC
re [comment 7]:
...as per rgmanager's code examination

Comment 10 Jan Pokorný [poki] 2015-10-16 19:37:02 UTC
Definitely 6.8 material.

Comment 11 Jan Pokorný [poki] 2015-10-16 19:43:06 UTC
[comment 10] applies just to [comment 7] that should rather be tracked
separately: [bug 1272587].

Comment 12 Jan Pokorný [poki] 2016-08-24 21:08:40 UTC
Not worth to pursuit at this point in the release cycle.
Unlike related [bug 1173942] that I am going to reopen.


Note You need to log in before you can comment on or make changes to this bug.